package com.dsic.gj_erp.service.jhgk.impl;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jcsj.DmBom;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.mapper.jcsj.DmBomMapper;
import com.dsic.gj_erp.mapper.jhgk.DmSygdMxMapper;
import com.dsic.gj_erp.mapper.jhgk.DmZrcjhMapper;
import com.dsic.gj_erp.service.jhgk.DmSygdMxService;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@Service
public class DmSygdMxServiceImpl extends ServiceImpl<DmSygdMxMapper, DmSygdMx> implements DmSygdMxService {

    @Resource
    private DmZrcjhMapper zrcjhMapper;
    @Resource
    private DmBomMapper bomMapper;

    @Override
    @Transactional
    public Map sygdPC(){
        //1.接下来3个月的 中日程 数据
//       List<DmZrcjh> zrcjhs= zrcjhMapper.selectList(new QueryWrapper<DmZrcjh>()
//                       .select("DC_CH,DC_PL,gjks,gjjs_dz,gjjs_xz,jsq_tlt,jsq_lqb,dhqd")
//               .between("gjks",
//                       "(SELECT CONVERT(varchar(10),DATEADD(m,1,DATEADD(dd,-DAY(GETDATE())+1,GETDATE())),111))",
//                       "(Select CONVERT(varchar(10), eomonth(GETDATE(),3), 111))")
//               .groupBy("DC_CH,DC_PL,gjks,gjjs_dz,gjjs_xz,jsq_tlt,jsq_lqb,dhqd")
//       );
//       if (zrcjhs.size()<1){
//           new Exception("中日程中没有未来三个月的数据！");
//       }
        //todo 应该用结束时间排 or
        //测试
        List<DmZrcjh> zrcjhs= zrcjhMapper.selectList(new QueryWrapper<DmZrcjh>()
                .select("DC_CH,stuff( ( SELECT ' ' + c.DC_FD FROM dm_zrcjh c  WHERE c.DC_CH=dm_zrcjh.DC_CH and c.DC_PL=dm_zrcjh.DC_PL FOR xml path ( '' ) ), 1, 1, '' ) AS dcFd," +
                        "DC_PL,gjks,gjjs_dz,gjjs_xz,jsq_tlt,jsq_lqb,dhqd")
                .between("gjks",
                        "2023/08/01",
                        "2023/08/31")
                .groupBy("DC_CH,DC_PL,gjks,gjjs_dz,gjjs_xz,jsq_tlt,jsq_lqb,dhqd")
        );
        //2.用中日程中的 船号 批量 ，在BOM中找明细
        List<DmSygdMx> mxList=new ArrayList<>();
        List<DmZrcjh> no_tlt=new ArrayList<>();

        for (DmZrcjh zrcjh : zrcjhs) {
            //②BOM中对应数据是否齐全
            List<DmBom> bomList= bomMapper.selectList(new QueryWrapper<DmBom>()
                    .select("dcch,sjch,pl,tzbh,lqlb,zl,wpgg,wpcz,kw,hxcd,qgcd,\n" +
                            "pklx,pkcd,qbs,dmcd,ljsl")
                    .eq("dcch",zrcjh.getDcCh())
                    .eq("pl",zrcjh.getDcPl().length()<3?"0"+zrcjh.getDcPl():zrcjh.getDcPl())
                    .eq("cs",3)
                    .groupBy("dcch,sjch,pl,tzbh,lqlb,zl,wpgg,wpcz,kw,hxcd,qgcd,\n" +
                            "pklx,pkcd,qbs,dmcd,ljsl")
            );
            if(bomList.size()<1){
                no_tlt.add(zrcjh);
            }else {
                bomToMx(zrcjh,bomList,mxList,"",zrcjh.getDcCh());
            }
        }
        Map map2= new HashMap();
        //根据有无套料图 分组 ，没有套料图的 获取船号list
        Map<String,List<DmZrcjh>> map=no_tlt.stream().collect(Collectors.groupingBy(DmZrcjh::getDcCh));
        if (map.size()>0){
            List<DmSygdMx> no_tlt_ch=new ArrayList<>();
            for (String s:map.keySet()){
                DmSygdMx m=new DmSygdMx();
                m.setDcCh(s);
                no_tlt_ch.add(m);
            }
            //BOM中有套料图的船
            List<DmBom> haveTltBoms= bomMapper.selectList(new QueryWrapper<DmBom>()
                    .select("dcch")
                    .eq("cs",3)
                    .groupBy("dcch"));
            map2.put("no_tlt",no_tlt);
            map2.put("no_tlt_ch",no_tlt_ch);
            map2.put("haveTltBoms",haveTltBoms);
        }else {
            ypc(mxList);
        }

        //3.给明细排产

        //4.明细数据 统计到主表中 数据返回到前端页面

        map2.put("mxList",mxList);
        return  map2;
    }

    @Override
    public List<DmSygdMx> saveByDcch(HashMap<String, List<Object>> map) {
        List<DmZrcjh> zrcjhs = BeanUtil.copyToList(map.get("no_tlt"), DmZrcjh.class);
        List<DmSygdMx> mxList= BeanUtil.copyToList(map.get("mxList"),DmSygdMx.class);
        List<DmSygdMx> no_tlt_ch= BeanUtil.copyToList(map.get("no_tlt_ch"),DmSygdMx.class);

        //1.
        for (DmZrcjh z:zrcjhs){
            for (DmSygdMx mx:no_tlt_ch){
                if (z.getDcCh().equals(mx.getDcCh())){
                    List<DmBom> bomList= bomMapper.selectList(new QueryWrapper<DmBom>()
                            .select("dcch,sjch,pl,tzbh,lqlb,zl,wpgg,wpcz,kw,hxcd,qgcd,\n" +
                                    "pklx,pkcd,qbs,dmcd,ljsl")
                            .eq("dcch",mx.getDcCh1())
                            .eq("pl",z.getDcPl().length()<3?"0"+z.getDcPl():z.getDcPl())
                            .eq("cs",3)
                            .groupBy("dcch,sjch,pl,tzbh,lqlb,zl,wpgg,wpcz,kw,hxcd,qgcd,\n" +
                                    "pklx,pkcd,qbs,dmcd,ljsl")
                    );
                    if(bomList.size()<1){
                        DmSygdMx mx1=new DmSygdMx();
                        zrcToMx(z,mx1);
                        mxList.add(mx1);
                    }else {
                        bomToMx(z,bomList,mxList,mx.getDcCh1(),"");
                    }
                }
            }
        }

            ypc(mxList);

        return mxList;
    }

    public  void zrcToMx(DmZrcjh zrcjh, DmSygdMx m){
        m.setDcCh(zrcjh.getDcCh());
        m.setDcPl(zrcjh.getDcPl());
        m.setDcFd(zrcjh.getDcFd());
        m.setGjks(zrcjh.getGjks());
        m.setGjjsDz(zrcjh.getGjjsDz());
        m.setGjjsXz(zrcjh.getGjjsXz());
        m.setJsqTlt(zrcjh.getJsqTlt());
        m.setJsqLqb(zrcjh.getJsqLqb());
        m.setDhqd(zrcjh.getDhqd());

    }
    public List<DmSygdMx> bomToMx(DmZrcjh zrcjh,List<DmBom> list,List<DmSygdMx> mxList,String mbch,String dcch){

        for (DmBom b:list){
            DmSygdMx mx=new DmSygdMx();
            zrcToMx(zrcjh,mx);
            mx.setZl(b.getZl());
            mx.setTzbh(b.getTzbh());
            mx.setLqlb(b.getLqlb());
            mx.setLx(b.getTzbh().substring(4,5).equals("X")?"X":"B");
            mx.setWpgg(b.getWpgg());
            mx.setWpxh(b.getWpcz());
            //型材米数
            mx.setLjsl(b.getLjsl());
            //区域
//            mx.setQy();
            mx.setKw(b.getKw());
            //上料日期
            //上料人员
            //矫正标识
            //矫正设备
            //矫正人员
            mx.setPw(b.getPw());
            //抛丸设备
            //抛丸人员
            //抛丸日期
            mx.setHxcd(b.getHxcd());
            //划线空程
            //划线设备
            //划线人员
            //划线日期
            mx.setQgcd(b.getQgcd());
            //切割空程
            //切割设备
            //切割人员
            //切割日期
            mx.setPklx(b.getPklx());
            mx.setPkcd(b.getPkcd());
            //坡口设备
            //坡口人员
            //坡口日期
            mx.setQbs(b.getQbs());
            //曲加工设备
            //曲加工人员
            //曲加工日期
            mx.setDmcd(b.getDmcd());
            //打磨设备
            //打磨人员
            //打磨日期
            mx.setDcCh2(dcch);
            mx.setDcCh1(mbch);
            mx.setGxsj(DateUtil.now());
            //todo
            if(b.getZl().equals("1110")){
                mx.setJssj(mx.getGjjsDz());
            }
            if(b.getZl().equals("1010")){
                mx.setJssj(mx.getGjjsXz());
            }

            mxList.add(mx);
        }

        return mxList;

    }

    public void ypc(List<DmSygdMx> list){
        //排序
        list =list.stream().sorted(Comparator.comparing(DmSygdMx::getJssj,Comparator.nullsLast(Comparator.naturalOrder()))).collect(Collectors.toList());
      //上料
        list.forEach(l->{
            //
        });
//        校平
        //抛丸

        //根据跨位分组
        Map<String,List<DmSygdMx>> groupByKw=list.stream().collect(Collectors.groupingBy(x->Optional.ofNullable(x.getKw()).orElse("0") ));
//        7	1跨平直大板
        List<DmSygdMx> k1pz=groupByKw.get("7");
        //排产
        k1pz.forEach(k->{
            //上料 校平 抛丸 理料 划线 切割 坡口 打磨

        });
//        8	    1跨进线板
        List<DmSygdMx> k1jx=groupByKw.get("8");
//        11	2跨T型材腹板
        List<DmSygdMx> k2tf=groupByKw.get("11");
//        5	    2跨T型材面板
        List<DmSygdMx> k2tm=groupByKw.get("5");
//        9	    2跨超长超宽板
        List<DmSygdMx> k2c=groupByKw.get("9");
//        10	2跨超长超宽曲板
        List<DmSygdMx> k2cq=groupByKw.get("10");
//        12	2跨激光切割板
        List<DmSygdMx> k2j=groupByKw.get("12");
//        14	3跨厚板
        List<DmSygdMx> k3h=groupByKw.get("14");
//        6	    3跨平铁
        List<DmSygdMx> k3p=groupByKw.get("6");
//        13	3跨曲板
        List<DmSygdMx> k3q=groupByKw.get("13");
//        15	4跨普通板
        List<DmSygdMx> k4p=groupByKw.get("15");
//        16	7跨型板
        List<DmSygdMx> k7x=groupByKw.get("16");
//        17	光电
        List<DmSygdMx> gd=groupByKw.get("17");

        System.out.println(groupByKw);
    }

}
